
UNAME := $(shell uname)

# cross-compile
ifeq ($(filter MINGW32% CYGWIN%, $(UNAME)),)
TOOL_PREFFIX := i586-mingw32msvc-
endif

CC    = $(TOOL_PREFFIX)gcc
CXX   = $(TOOL_PREFFIX)g++
AR    = $(TOOL_PREFFIX)ar
STRIP = $(TOOL_PREFFIX)strip

CCFLAGS  = -Wall -MMD -g
CXXFLAGS = -Wall -MMD -g

WINDRES := $(TOOL_PREFFIX)windres

ifneq ($(findstring CYGWIN,$(UNAME)),)
CC  += -mno-cygwin
CXX += -mno-cygwin

CXXFLAGS += -fno-rtti

# for windres
export CLANG = C-SJIS
endif

ifndef MAKEFILE_LIST
MAKEFILE_LIST = Makefile
endif

MAKEFILE = $(firstword $(MAKEFILE_LIST))

MAKEFLAGS_SHORT = $(filter -%,$(filter-out --%,$(MAKEFLAGS)))
MAKEFLAGS += -R -r

# Check -w option
ifeq (,$(findstring w,$(MAKEFLAGS_SHORT)))
MAKEFLAGS += --no-print-directory
endif

# Check -k option
ifeq (,$(findstring k,$(MAKEFLAGS_SHORT)))
AND := &&
else
AND := ;
endif

REMAKE := $(MAKE) -f $(MAKEFILE)

define MAKE_SUBDIR
	+$(foreach DIR,$(SUBDIRS),$(MAKE) $(SUBDIR_FLAGS) -C $(DIR) $(MAKECMDGOALS) $(AND)) true
	+$(foreach FILE,$(SUBMAKES),$(MAKE) $(SUBDIR_FLAGS) -C $(dir $(FILE)) -f $(notdir $(FILE)) $(MAKECMDGOALS) $(AND)) true
endef

.PHONY: default all build

default all: build

TARGETS += $(TARGET_BIN) $(TARGET_LIB) $(TARGET_DLL)

OBJDIR ?= .obj
